//
// Color system
//

$white: #ffffff !default;
$black: #000000 !default;

$logo-red: #e24329 !default;
$logo-orange: #fc6d26 !default;
$logo-yellow: #fca326 !default;

$blue-50: #f6fafe !default;
$blue-100: #e4f0fb !default;
$blue-200: #b8d6f4 !default;
$blue-300: #73afea !default;
$blue-400: #418cd8 !default;
$blue-500: #1f78d1 !default;
$blue-600: #1b69b6 !default;
$blue-700: #17599c !default;
$blue-800: #134a81 !default;
$blue-900: #0f3b66 !default;
$blue-950: #0a2744 !default;

$green-50: #f1fdf6 !default;
$green-100: #dcf5e7 !default;
$green-200: #b3e6c8 !default;
$green-300: #75d09b !default;
$green-400: #37b96d !default;
$green-500: #1aaa55 !default;
$green-600: #168f48 !default;
$green-700: #12753a !default;
$green-800: #0e5a2d !default;
$green-900: #0a4020 !default;
$green-950: #072b15 !default;

$red-50: #fef6f5 !default;
$red-100: #fbe5e1 !default;
$red-200: #f2b4a9 !default;
$red-300: #ea8271 !default;
$red-400: #e05842 !default;
$red-500: #db3b21 !default;
$red-600: #c0341d !default;
$red-700: #a62d19 !default;
$red-800: #8b2615 !default;
$red-900: #711e11 !default;
$red-950: #4b140b !default;

$orange-50: #fffaf4 !default;
$orange-100: #fff1de !default;
$orange-200: #fed69f !default;
$orange-300: #fdbc60 !default;
$orange-400: #fca429 !default;
$orange-500: #fc9403 !default;
$orange-600: #de7e00 !default;
$orange-700: #c26700 !default;
$orange-800: #a35200 !default;
$orange-900: #853c00 !default;
$orange-950: #592800 !default;

$purple-50: #f9f7fe !default;
$purple-100: #ede8fc !default;
$purple-200: #d0c3f6 !default;
$purple-300: #b29df1 !default;
$purple-400: #9578eb !default;
$purple-500: #805de7 !default;
$purple-600: #6e49cb !default;
$purple-700: #5c35ae !default;
$purple-800: #4a2192 !default;
$purple-900: #380d75 !default;
$purple-950: #25094e !default;

$gray-50: #fafafa !default;
$gray-100: #f2f2f2 !default;
$gray-200: #dfdfdf !default;
$gray-300: #cccccc !default;
$gray-400: #bababa !default;
$gray-500: #a7a7a7 !default;
$gray-600: #949494 !default;
$gray-700: #707070 !default;
$gray-800: #4f4f4f !default;
$gray-900: #2e2e2e !default;
$gray-950: #1f1f1f !default;

$colors: () !default;
$colors: map-merge(
  (
    "blue": $blue-500,
    "green": $green-500,
    "red": $red-500,
    "orange": $orange-500,
    "purple": $purple-500,
    "gray": $gray-500
  ),
  $colors
);

// Scales

$grid-scale-1: px-to-rem(1px) !default;
$grid-scale-2: px-to-rem(2px) !default;
$grid-scale-3: px-to-rem(4px) !default;
$grid-scale-4: px-to-rem(8px) !default;
$grid-scale-5: px-to-rem(12px) !default;
$grid-scale-6: px-to-rem(16px) !default;
$grid-scale-7: px-to-rem(24px) !default;
$grid-scale-8: px-to-rem(32px) !default;
$grid-scale-9: px-to-rem(48px) !default;
$grid-scale-10: px-to-rem(64px) !default;
$grid-scale-11: px-to-rem(96px) !default;
$grid-scale-12: px-to-rem(128px) !default;
$grid-scale-13: px-to-rem(176px) !default;
$grid-scale-14: px-to-rem(256px) !default;

$type-scale-1: px-to-rem(12px) !default;
$type-scale-2: px-to-rem(14px) !default;
$type-scale-3: px-to-rem(16px) !default;
$type-scale-4: px-to-rem(20px) !default;
$type-scale-5: px-to-rem(24px) !default;
$type-scale-6: px-to-rem(28px) !default;
$type-scale-7: px-to-rem(42px) !default;

// Fonts

$font-family-sans-serif: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto,
  Oxygen-Sans, Ubuntu, Cantarell, "Helvetica Neue", sans-serif,
  "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";
$font-family-monospace: "Menlo", "DejaVu Sans Mono", "Liberation Mono",
  "Consolas", "Ubuntu Mono", "Courier New", "andale mono", "lucida console",
  monospace;
$font-family-base: $font-family-sans-serif !default;
$font-family-emoji: "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol",
  "Noto Color Emoji" !default;

// $font-size-base is defined in functions-variables.scss
$line-height-base: $grid-scale-6 !default;

$border-radius-base: $grid-scale-3 !default;

$transition-base: background-color 100ms linear, color 100ms linear,
  border 100ms linear;

$primary-type-color: $gray-900 !default;
$secondary-type-color: $gray-700 !default;

$bold-base: 600 !default;

// Components

$border-width: $grid-scale-1 !default;
$border-color: $gray-300 !default;
$border-color-secondary: $gray-200 !default;
$border-color-tertiary: rgba(0, 0, 0, 0.1) !default;
$border: solid $border-width $border-color !default;

// Body

$body-font-size: $type-scale-2 !default;

// Typography

$h1-font-size: $type-scale-6 !default;
$h2-font-size: $type-scale-4 !default;
$h3-font-size: $type-scale-2 !default;
$h4-font-size: $type-scale-1 !default;
$h5-font-size: $type-scale-1 !default;
$h6-font-size: $type-scale-1 !default;

$h1-line-height: $grid-scale-8 !default;
$h2-line-height: $grid-scale-7 !default;
$h3-line-height: $grid-scale-6 !default;
$h4-line-height: $grid-scale-6 !default;
$h5-line-height: $grid-scale-6 !default;
$h6-line-height: $grid-scale-6 !default;

$p-font-size: $type-scale-2 !default;
$p-line-height: $grid-scale-7 !default;
$p-margin: 0 !default;

$headings-font-weight: 600 !default;
$headings-margin: 0 !default;

$link-color: $blue-600 !default;

// Components

$border-width: $grid-scale-1 !default;
$border-color: $gray-300 !default;
$border: solid $border-width $border-color !default;

// Markdown

$markdown-h1-font-size: $type-scale-7 !default;
$markdown-h2-font-size: $type-scale-6 !default;
$markdown-h3-font-size: $type-scale-4 !default;
$markdown-h4-font-size: $type-scale-3 !default;
$markdown-h5-font-size: $type-scale-2 !default;
$markdown-h6-font-size: $type-scale-2 !default;

$markdown-h1-line-height: $grid-scale-9 !default;
$markdown-h2-line-height: $grid-scale-8 !default;
$markdown-h3-line-height: $grid-scale-7 !default;
$markdown-h4-line-height: $grid-scale-7 !default;
$markdown-h5-line-height: px-to-rem(20px) !default;
$markdown-h6-line-height: px-to-rem(20px) !default;

$markdown-h1-margin: $grid-scale-7 0 $grid-scale-6 0 !default;
$markdown-h2-margin: $grid-scale-7 0 $grid-scale-6 0 !default;
$markdown-h3-margin: $grid-scale-7 0 $grid-scale-4 0 !default;
$markdown-h4-margin: $grid-scale-7 0 $grid-scale-4 0 !default;
$markdown-h5-margin: $grid-scale-7 0 $grid-scale-4 0 !default;
$markdown-h6-margin: $grid-scale-7 0 $grid-scale-4 0 !default;

$markdown-h1-padding-bottom: $grid-scale-6 !default;
$markdown-h2-padding-bottom: $grid-scale-6 !default;

$markdown-p-font-size: $type-scale-3 !default;
$markdown-p-line-height: $grid-scale-7 !default;
$markdown-p-margin: 0 0 $grid-scale-6 0 !default;

$markdown-monospace-font-size: px-to-rem(
  15px
) !default; // Monospace size is special, does not fit in type-scale
$markdown-mention-link-padding: 0 $grid-scale-3 !default;
$markdown-mention-link-background: $blue-50 !default;
$markdown-mention-link-hover-background: $blue-100 !default;

$markdown-code-color: $red-600 !default;
$markdown-code-background-color: $red-100 !default;
$markdown-code-padding: 0 $grid-scale-3 !default;

$markdown-color-chip-width: $grid-scale-6 !default;
$markdown-color-chip-height: $grid-scale-6 !default;
$markdown-color-chip-margin: 0 0 0 $grid-scale-3 !default;

$markdown-blockquote-background: $gray-50 !default;
$markdown-blockquote-border-width: $grid-scale-2 !default;
$markdown-blockquote-padding: $grid-scale-6 !default;
$markdown-blockquote-margin: 0 0 $grid-scale-6 $grid-scale-7 !default;

$markdown-inline-diff-padding: 0 $grid-scale-2 !default;
$markdown-inline-diff-radius: $grid-scale-2 !default;
$markdown-inline-diff-addition-color: $green-800 !default;
$markdown-inline-diff-addition-background: $green-100 !default;
$markdown-inline-diff-deletion-color: $red-800 !default;
$markdown-inline-diff-deletion-background: $red-100 !default;

$markdown-list-item-line-height: $grid-scale-7 !default;
$markdown-list-left-margin: $grid-scale-7 !default;
$markdown-list-bottom-margin: $grid-scale-6 !default;
$markdown-list-input-right: $grid-scale-4 !default;
$markdown-list-input-bottom: $grid-scale-3 !default;
$markdown-list-input-left: px-to-rem(
  -20px
) !default; // Aligns task list inputs with other list items
$markdown-list-input-size: $type-scale-1 !default;

$markdown-table-padding: $grid-scale-4 $grid-scale-6 !default;
$markdown-table-header-background: $gray-50 !default;
$markdown-table-font-size: $type-scale-3 !default;
$markdown-table-line-height: $grid-scale-7 !default;
$markdown-table-margin: 0 0 $grid-scale-6 0 !default;
$markdown-table-border: $border !default;

$markdown-emoji-font-family: $font-family-emoji !default;
$markdown-emoji-font-size: 1.5em !default;
$markdown-emoji-line-height: 0.5 !default;

$markdown-pre-font-size: $markdown-monospace-font-size !default;
$markdown-pre-margin: 0 0 $grid-scale-6 0 !default;
$markdown-pre-padding: $grid-scale-4 $grid-scale-5 !default;
$markdown-pre-border-color: $border-color-tertiary !default;
$markdown-pre-border-radius: 0 !default;
$markdown-pre-line-height: $grid-scale-7 !default;
$markdown-pre-code-padding: 0 !default;

$markdown-pre-highlight-selectors: () !default;
$markdown-pre-highlight-selectors: map-merge(
  (
    "white": (
      "background": $white-highlight-background,
      "selectors": $white-highlight-selectors
    ),
    "dark": (
      "color": $dark-highlight-text-color,
      "background": $dark-highlight-background,
      "selectors": $dark-highlight-selectors
    ),
    "monokai": (
      "color": $monokai-highlight-text-color,
      "background": $monokai-highlight-background,
      "selectors": $monokai-highlight-selectors
    ),
    "solarized-light": (
      "color": $solarized-light-highlight-text-color,
      "background": $solarized-light-highlight-background,
      "selectors": $solarized-light-highlight-selectors
    ),
    "solarized-dark": (
      "color": $solarized-dark-highlight-text-color,
      "background": $solarized-dark-highlight-background,
      "selectors": $solarized-dark-highlight-selectors
    )
  ),
  $markdown-pre-highlight-selectors
);
